var autenticacaopage = require ('../../../page-objects/autenticacao.po.js'),
geral_page = require ('../../../page-objects/geral.po.js'),
geral_tecfood_po = require ('../../../page-objects/geral_tecfood.po');
servicoPage = require('../../../page-objects/servico.po.js'),
menuPage = require('../../../page-objects/menu.po.js'),
help = require('../../../helper/helper.js');
var zh = require('../../../../src/frameworkFunctionalTests.js');



describe ('Login', function () {

	it ('Informa os dados de login válido e verifica se houve acesso à tela inicial', function () {
		autenticacaopage.login('joana.almeida@teknisa.com', '1');
		//expect (autenticacaopage.telaInicial.getText()).toContain('Início');
	});
});


describe('Gerar dados de serviço', function(){

	it('Abrir tela de Serviço', function(){
		menuPage.Pesquisa('Serviço');
	});

	it('Clicar em adicionar', function(){
		geral_page.clicaEmAdicionar();
		expec(zh.isSwipePresent()).toBe(true);
		expect(servicoPage.Fields.nome.isPresent()).toBe(true);
	});

	it('Não preencher campos obrigatórios', function(){
		geral_page.clicaEmSalvar();
		//expect(element(by.css('.zh-validation-error')).isPresent()).toBe(true); //validação e campo obrigatório
		expect(zh.validationError()).toBe(true);s
		expect(servicoPage.Fields.nome.isPresent()).toBe(true);
	});

	it('Preencher "Código" e "Nome"',function(){
		geral_tecfood_po.filtraServico('COLACAO INTEGRAL');
		geral_page.clicaEmSalvar();
		expect(servicoPage.Fields.nome.isPresent()).toBe(true);
	});
	
	it('Preencher "Grupo de Serviço"',function(){
		geral_tecfood_po.filtraGrupoServico('DESJEJUM');
		geral_page.clicaEmSalvar();
		expect(servicoPage.Fields.nome.isPresent()).toBe(true);
	});

	it('Preencher "Hora Início Preparo"',function(){
		servicoPage.Horaini('1500');
		geral_page.clicaEmSalvar();
		expect(servicoPage.Fields.nome.isPresent()).toBe(false);
	});

	it('Verificar Cadastro',function(){
		geral_page.Pesquisar('COLACAO INTEGRAL');
		help.waitFiltro(servicoPage.Fields.gridNmservico,'COLACAO INTEGRAL');
		expect(servicoPage.Fields.gridNmservico.getText()).toBe('COLACAO INTEGRAL');
		geral_page.fecharPesquisa();
	});
});

/*describe('Alteração de Cadastro',function(){
	it('Localizar um serviço e editá-lo',function(){
		//servicoPage.editarServico('COLACAO INTEGRAL');
		geral_page.Pesquisar('COLACAO INTEGRAL');
        help.waitFiltro(servicoPage.Fields.gridNmservico,'COLACAO INTEGRAL');
		expect(servicoPage.Fields.gridNmservico.getText()).toBe('COLACAO INTEGRAL');
		servicoPage.clicarEmServico();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.codigo.isPresent()).toBe(true);
	});

	it('Campo "Código" deve estar bloqueado',function(){
 		expect(servicoPage.Fields.codigo.getAttribute('readonly')).toBe('true');
	});
	
	it('Campo "Nome" deve estar bloqueado',function(){
        expect(servicoPage.Fields.nome.getAttribute('readonly')).toBe('true');    
	});
	
	it('Campo "Tipo de Serviço" deve estar bloqueado', function(){
		expect(servicoPage.Fields.tipo.getAttribute('readonly')).toBe('true');
	});
	
	it('Alterar Nome Reduzido',function(){
		servicoPage.Nomereduz('MMTX');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.nomereduz.getAttribute('value')).toBe('MMTX');
	});
	
	it('Alterar Nome Fantasia', function(){
		servicoPage.Nomefant('MMTX ALM');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.nomefant.getAttribute('value')).toBe('MMTX ALM');
	});
	
	it('Alterar Grupo de Serviço', function(){
		geral_tecfood_po.filtraGrupoServico('JANTAR');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.textogrupo.getText()).toBe('JANTAR');
	});

	it('Alterar Hora Início', function(){ 
 		servicoPage.Horaini('1400');
 		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
 		expect(servicoPage.Fields.horaini.getAttribute('value')).toBe('14:00');
	});

	it('Alterar Hora de Entrega',function(){
		servicoPage.Horaentre('1500');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.horaentre.getAttribute('value')).toBe('15:00');
	});

	it('Alterar Hora Servido De',function(){
		servicoPage.Horaservde('1500');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.horaservde.getAttribute('value')).toBe('15:00');
	});

	it('Alterar Hora Servido Até',function(){
		servicoPage.Horaservate('1700');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.horaservate.getAttribute('value')).toBe('17:00');
	});	

	it('Alterar Especificacao',function(){
		servicoPage.especifica(3);
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.textoespecificacao.getText()).toBe('Lactário');
	});
	
	it('Marcar parâmetros', function(){
		servicoPage.Fields.configuracao.click();
		servicoPage.ParamPadrao();
		geral_page.clicaEmSalvar();
		geral_page.clicaEmVoltar();
		geral_page.fecharPesquisa();
	});
});

describe('Gerar Dados [CONFIGURAÇÃO PADRÃO]', function(){
	it('Localizar um serviço', function(){
		geral_page.Pesquisar('COLACAO INTEGRAL');
		help.waitFiltro(servicoPage.Fields.gridNmservico,'COLACAO INTEGRAL');
		expect(servicoPage.Fields.gridNmservico.getText()).toBe('COLACAO INTEGRAL');
		servicoPage.Fields.gridServico.click();
	});

	it('Navegar a aba [CONFIGURAÇÃO PADRÃO] e adiciona um tipo de prato', function(){
		servicoPage.AbrirConfiguracaoPadrao();
		geral_page.clicaEmAdicionar();
		geral_tecfood_po.filtraTipoDePrato('MANTEIGA');
		geral_page.clicaEmSalvar();

		expect(servicoPage.Fields.gridConfiguracaoPadrao.getText()).toBe('MANTEIGA');
	});

	it('Adicionar um segundo tipo de prato', function(){
		geral_page.clicaEmAdicionar();
		geral_tecfood_po.filtraTipoDePrato('LANCHE');
		geral_page.clicaEmSalvar();
	});

	it('Editar campo "complemento"', function(){
		servicoPage.Fields.gridConfiguracaoPadrao.click();
		geral_page.clicaEmEditar();
		servicoPage.Complemento('Complemento');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.complemento.getAttribute('value')).toBe('Complemento');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});

	it('Editar campo "Observação"',function(){
		servicoPage.Fields.gridConfiguracaoPadrao.click();
		geral_page.clicaEmEditar();
		servicoPage.Observacao('Observação');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.observacao.getAttribute('value')).toBe('Observação');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});

	it('Editar campo "Embalagem"', function(){
		servicoPage.Fields.gridConfiguracaoPadrao.click();
		geral_page.clicaEmEditar();
		servicoPage.Embalagem('Embalagem');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.embalagem.getAttribute('value')).toBe('Embalagem');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});

	it('Marcar checkbox "Opção"', function(){
		servicoPage.Fields.gridConfiguracaoPadrao.click();
		geral_page.clicaEmEditar();
		servicoPage.Fields.opcao.click();
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.opcaoCheck.getAttribute('checked')).toBe('true');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});

	it('Marcar checkbox "Impressão"',function(){
		servicoPage.Fields.gridConfiguracaoPadrao.click();
		geral_page.clicaEmEditar();
		servicoPage.Fields.impressao.click();
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.impressaoCheck.getAttribute('checked')).toBe('true');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});

	it('Marcar checkbox "Consiste Comensais"',function(){
		servicoPage.Fields.gridConfiguracaoPadrao.click();
		geral_page.clicaEmEditar();
		servicoPage.Fields.consisteComensais.click();
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.consisteComensaisCheck.getAttribute('checked')).toBe('true');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});

	it('Excluir um tipo de prato', function(){
		servicoPage.Fields.gridConfiguracaoPadrao.click();
		geral_page.clicaEmExcluir();
		geral_page.clicaEmSim();
		geral_page.clicaEmOk();
		expect(servicoPage.Fields.gridConfiguracaoPadrao.getText()).toBe('LANCHE');
	});

	it('Fechar Swipe', function(){
		geral_page.clicaEmVoltar();
		geral_page.fecharPesquisa();
	})
});

describe('Gerar dados [CUSTO PADRÃO]', function(){

	/*it('Localizar um serviço', function(){
		geral_page.Pesquisar('COLACAO INTEGRAL');
		help.waitFiltro(servicoPage.Fields.gridNmservico,'COLACAO INTEGRAL');
		expect(servicoPage.Fields.gridNmservico.getText()).toBe('COLACAO INTEGRAL');
		servicoPage.Fields.gridServico.click();
	});

	it('Navegar a aba [CUSTO PADRÃO] e adicionar dados', function(){
		servicoPage.AbrirCustoPadrao();
		geral_page.clicaEmAdicionar();
		servicoPage.Valor('16,50000');
		geral_page.clicaEmSalvar();

		servicoPage.Fields.gridCusto.click();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.valor.getAttribute('value')).toBe('16,50000');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});

	it('Editar Custo Padrão cadastrado', function(){
		servicoPage.Fields.gridCusto.click();
		geral_page.clicaEmEditar();
		servicoPage.Valor('15,6');
		geral_page.clicaEmSalvar();

		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.valor.getAttribute('value')).toBe('15,60000');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});

	it('Excluir Custo Padrão', function(){
		servicoPage.Fields.gridCusto.click();
		geral_page.clicaEmExcluir();
		geral_page.clicaEmSim();
		geral_page.clicaEmOk();
		expect(servicoPage.Fields.gridCustoVazio.getText()).toBe('Não há registros');
	});

	it('Fechar o Swipe', function(){
		geral_page.clicaEmVoltar();
		geral_page.fecharPesquisa();
	});
});

describe('Gerar dados [TURNOS E COMENSAIS]', function(){
	it('Localizar um serviço', function(){
		//browser.driver.sleep(10000);
		geral_page.Pesquisar('COLACAO INTEGRAL');
		help.waitFiltro(servicoPage.Fields.gridNmservico,'COLACAO INTEGRAL');
		expect(servicoPage.Fields.gridNmservico.getText()).toBe('COLACAO INTEGRAL');
		servicoPage.Fields.gridServico.click();
	});

	it('Navegar a aba [TURNOS E COMENSAIS] e não preencher os dados obrigatórios', function(){
		servicoPage.AbrirTurnosComensais();
		geral_page.clicaEmAdicionar();
		servicoPage.NomeTurno('Manhã','');
		geral_page.clicaEmSalvar();
		expect(servicoPage.Fields.nomeTurno1.isPresent()).toBe(true);
	});

	it('Preencher os campos obrigatórios', function(){
		servicoPage.NomeTurno('Tarde','Noite');
		geral_page.clicaEmSalvar();
		expect(servicoPage.Fields.gridTurno.getText()).toBe('Tarde');
	});
});
describe('Editar o primeiro turno', function(){

	it('Editar turno - segunda', function(){
		//geral_page.Pesquisar('Tarde');
		//help.waitFiltro(servicoPage.Fields.gridTurno,'Tarde');
		expect(servicoPage.Fields.gridTurno.getText()).toBe('Tarde');
		servicoPage.Fields.gridTurno.click();

		geral_page.clicaEmEditar();
		servicoPage.ComensalSeg('20');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.seg.getAttribute('value')).toBe('20');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - terça', function(){


		geral_page.clicaEmEditar();
		servicoPage.ComensalTer('30');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.ter.getAttribute('value')).toBe('30');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Quarta', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalQua('40');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.qua.getAttribute('value')).toBe('40');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Quinta', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalQui('50');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.qui.getAttribute('value')).toBe('50');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Sexta', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalSex('60');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.sex.getAttribute('value')).toBe('60');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Sábado', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalSab('70');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.sab.getAttribute('value')).toBe('70');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Domingo', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalDom('80');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.dom.getAttribute('value')).toBe('80');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Feriado', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalFer('90');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.fer.getAttribute('value')).toBe('90');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});
});
describe('Editar o segundo turno', function(){

	it('Editar turno - segunda', function(){

		servicoPage.selecionaTurno(2);
		geral_page.clicaEmEditar();
		servicoPage.ComensalSeg('25');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.seg.getAttribute('value')).toBe('25');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - terça', function(){


		geral_page.clicaEmEditar();
		servicoPage.ComensalTer('35');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.ter.getAttribute('value')).toBe('35');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Quarta', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalQua('45');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.qua.getAttribute('value')).toBe('45');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Quinta', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalQui('55');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.qui.getAttribute('value')).toBe('55');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Sexta', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalSex('65');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.sex.getAttribute('value')).toBe('65');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Sábado', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalSab('75');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.sab.getAttribute('value')).toBe('75');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Domingo', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalDom('85');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.dom.getAttribute('value')).toBe('85');
		geral_page.clicaEmCancelar();
	});
	it('Editar turno - Feriado', function(){

		geral_page.clicaEmEditar();
		servicoPage.ComensalFer('95');
		geral_page.clicaEmSalvar();
		geral_page.clicaEmEditar();
		expect(servicoPage.Fields.fer.getAttribute('value')).toBe('95');
		geral_page.clicaEmCancelar();
		geral_page.clicaEmVoltar();
	});
});
/*describe('Excluir turno', function(){

	it('Excluir turno - noite', function(){

		browser.driver.sleep(2000);
		servicoPage.selecionaTurno(2).click();
		geral_page.clicaEmExcluir();
		geral_page.clicaEmSim(); 
		geral_page.clicaEmOk();
		expect(servicoPage.Fields.gridTurnoVazio.getText()).toBe('Não há registros');
	});
	it('Fechar o Swipe', function(){
		geral_page.clicaEmVoltar();
		geral_page.fecharPesquisa();
	});
});
describe('Gerar dados [COMENSAIS ESTIMADOS]', function(){
	it('Localizar um serviço', function(){
		servicoPage.FiltrarServico('COLACAO INTEGRAL');
		expect(servicoPage.Fields.gridNmservico.getText()).toBe('COLACAO INTEGRAL');
	});

	it('Navegar a aba [COMENSAIS ESTIMADOS]', function(){
		servicoPage.AbrirComensaisEstimados();
		expect(servicoPage.Fields.diaBase.isPresent()).toBe(true);
	});
	it('Editar comensal segunda [CLIENTE]', function(){
		servicoPage.editaComensal('segunda','cliente',12);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('segunda','cliente').getAttribute('value')).toBe('12');	
	});
	it('Editar comensal terça [CLIENTE]', function(){
		servicoPage.editaComensal('terca','cliente',13);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('terca','cliente').getAttribute('value')).toBe('13');
	});
	it('Editar comensal quarta [CLIENTE]', function(){
		servicoPage.editaComensal('quarta','cliente',14);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('quarta','cliente').getAttribute('value')).toBe('14');
	});
	it('Editar comensal quinta [CLIENTE]', function(){
		servicoPage.editaComensal('quinta','cliente',15);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('quinta','cliente').getAttribute('value')).toBe('15');
	});
	it('Editar comensal sexta [CLIENTE]', function(){
		servicoPage.editaComensal('sexta','cliente',16);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('sexta','cliente').getAttribute('value')).toBe('16');
	});
	it('Editar comensal sabado [CLIENTE]', function(){
		servicoPage.editaComensal('sabado','cliente',17);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('sabado','cliente').getAttribute('value')).toBe('17');
	});
	it('Editar comensal domingo [CLIENTE]', function(){
		servicoPage.editaComensal('domingo','cliente',18);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('domingo','cliente').getAttribute('value')).toBe('18');
	});
	it('Editar comensal feriado [CLIENTE]', function(){
		servicoPage.editaComensal('feriado','cliente',19);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('feriado','cliente').getAttribute('value')).toBe('19');
	});
});
describe('Gerar dados [COMENSAIS ESTIMADOS] funcionários', function(){
	it('Navegar a aba [COMENSAIS ESTIMADOS]', function(){
		servicoPage.AbrirComensaisEstimados();
		expect(servicoPage.Fields.diaBase.isPresent()).toBe(true);
	});
	it('Editar comensal segunda [FUNCIONARIO]', function(){
		servicoPage.editaComensal('segunda','funcionario',22);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('segunda','funcionario').getAttribute('value')).toBe('22');	
	});
	it('Editar comensal terça [FUNCIONARIO]', function(){
		servicoPage.editaComensal('terca','funcionario',23);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('terca','funcionario').getAttribute('value')).toBe('23');
	});
	it('Editar comensal quarta [FUNCIONARIO]', function(){
		servicoPage.editaComensal('quarta','funcionario',24);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('quarta','funcionario').getAttribute('value')).toBe('24');
	});
	it('Editar comensal quinta [FUNCIONARIO]', function(){
		servicoPage.editaComensal('quinta','funcionario',25);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('quinta','funcionario').getAttribute('value')).toBe('25');
	});
	it('Editar comensal sexta [FUNCIONARIO]', function(){
		servicoPage.editaComensal('sexta','funcionario',26);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('sexta','funcionario').getAttribute('value')).toBe('26');
	});
	it('Editar comensal sabado [FUNCIONARIO]', function(){
		servicoPage.editaComensal('sabado','funcionario',27);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('sabado','funcionario').getAttribute('value')).toBe('27');
	});
	it('Editar comensal domingo [FUNCIONARIO]', function(){
		servicoPage.editaComensal('domingo','funcionario',28);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('domingo','funcionario').getAttribute('value')).toBe('28');
	});
	it('Editar comensal feriado [FUNCIONARIO]', function(){
		servicoPage.editaComensal('feriado','funcionario',29);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('feriado','funcionario').getAttribute('value')).toBe('29');
	});
});
describe('Gerar dados [COMENSAIS ESTIMADOS] doações', function(){
	it('Navegar a aba [COMENSAIS ESTIMADOS]', function(){
		servicoPage.AbrirComensaisEstimados();
		expect(servicoPage.Fields.diaBase.isPresent()).toBe(true);
	});
	it('Editar comensal segunda [DOACAO]', function(){
		servicoPage.editaComensal('segunda','doacao',32);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('segunda','doacao').getAttribute('value')).toBe('32');	
	});
	it('Editar comensal terça [DOACAO]', function(){
		servicoPage.editaComensal('terca','doacao',33);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('terca','doacao').getAttribute('value')).toBe('33');
	});
	it('Editar comensal quarta [DOACAO]', function(){
		servicoPage.editaComensal('quarta','doacao',34);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('quarta','doacao').getAttribute('value')).toBe('34');
	});
	it('Editar comensal quinta [DOACAO]', function(){
		servicoPage.editaComensal('quinta','doacao',35);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('quinta','doacao').getAttribute('value')).toBe('35');
	});
	it('Editar comensal sexta [DOACAO]', function(){
		servicoPage.editaComensal('sexta','doacao',36);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('sexta','doacao').getAttribute('value')).toBe('36');
	});
	it('Editar comensal sabado [DOACAO]', function(){
		servicoPage.editaComensal('sabado','doacao',37);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('sabado','doacao').getAttribute('value')).toBe('37');
	});
	it('Editar comensal domingo [DOACAO]', function(){
		servicoPage.editaComensal('domingo','doacao',38);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('domingo','doacao').getAttribute('value')).toBe('38');
	});
	it('Editar comensal feriado [DOACAO]', function(){
		servicoPage.editaComensal('feriado','doacao',39);
		help.waitElementVisibility(geral_page.btnSalvar);
		geral_page.clicaEmSalvar();
		expect(servicoPage.getElementoDiaSemana('feriado','doacao').getAttribute('value')).toBe('39');
	});
	it('Fechar o Swipe', function(){
		geral_page.clicaEmVoltar();
		geral_page.fecharPesquisa();
	});
});

describe('Gerar Dados [FATURAMENTO]',function(){

	it('Localizar um serviço', function(){
		servicoPage.FiltrarServico('COLACAO INTEGRAL');
		expect(servicoPage.Fields.gridNmservico.getText()).toBe('COLACAO INTEGRAL');
	});

	it('Abrir aba Faturamento', function(){
		servicoPage.AbrirFaturamento();
		expect(servicoPage.Fields.servicoFaturamento.isPresent()).toBe(true);
	});

	it('Adicionar um serviço de faturamento', function(){
		geral_page.clicaEmAdicionar();
		geral_tecfood_po.filtraServico('LANCHE I SMATRAC');
		geral_page.clicaEmSalvar();
		expect(servicoPage.Fields.gridServicoFatu.getText()).toBe('LANCHE I SMATRAC');
	});

	it('Excluir serviço de faturamento', function(){
		servicoPage.SelecionarServico();
		geral_page.clicaEmExcluir();
		//element(by.css('#footer > div.zh-footer-center > ul > li > a > div')).click();
		geral_page.clicaEmSim();
		geral_page.clicaEmOk();
		geral_page.Pesquisar('COLACAO INTEGRAL');
        help.waitFiltro(servicoPage.Fields.gridNmservico,'COLACAO INTEGRAL');
		expect(servicoPage.Fields.gridNmservico.getText()).toBe('Não há registros');

	});


});*/
/*describe('Excluir Serviço',function(){
	it('Exluir último cadastro', function()
	{
		//servicoPage.Cancelar();
		servicoPage.Excluir();
        browser.waitForAngular();
        help.waitElementVisibility(servicoPage.Fields.gridVazio);
        expect(servicoPage.Fields.gridVazio.getText()).toBe('No records were found');
	});
});*/