var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
var z = new ZeedhiAPIConstructor(browser, protractor);

var loginPage = require('./page objects/login.po.js');
var menuPage = require('./page objects/menu.po.js');
var util = require('./page objects/util.po.js');

var elaboracaoDoCardapioPage = require('./page objects/elaboracaoDoCardapio.po.js');
var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');
var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');
var efetivosPlanejamentoPage = require('./page objects/efetivosPlanejamento.po.js');


var decache = require('decache');

describe('Teste Efetivos (Planejamento) - Filial 0002', function() {

    beforeEach(function(){
        decache('zeedhi-functional-test-api');
        var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
        var z = new ZeedhiAPIConstructor(browser, protractor);

        decache('./page objects/login.po.js');
        var loginPage = require('./page objects/login.po.js');

        z.application.openOnContainer('#/product#dashboard');
        browser.driver.manage().window().maximize();

        browser.sleep(3000);
        browser.waitForAngular();
        loginPage.login('joana.almeida@teknisa.com','1');
        browser.waitForAngular();
        z.application.waitZhLoading();
    });

it('Deve acessar a tela [Medição de Efetivos] ', function() {
        efetivosPlanejamentoPage.abrir();
        expect(browser.getCurrentUrl()).toContain('pla01000_efetivos');
    }, 30000);

it ('Deve preencher o filtro, os campos e salvar', function() {
        decache('./page objects/efetivosPlanejamento.po.js');
        var efetivosPlanejamentoPage = require('./page objects/efetivosPlanejamento.po.js');
        
        efetivosPlanejamentoPage.abrir();
        //browser.sleep(3000);
        efetivosPlanejamentoPage.filtroInicial ('24/01/2018', 'MARMITEX ALMOCO');
        
        efetivosPlanejamentoPage.preencheEfetivos ('100','10','15');

        //z.widget.grid.getText('35054435228195666132480',1,4,false,false);
        expect(efetivosPlanejamentoPage.textoColuna ('35054435228195666132480',4,false)).toBe('125');
});

it ('Deve verificar a possibilidade de preencher efetivos em dia sem cardápio planejado', function(){
    decache('./page objects/elaboracaoDoCardapio.po.js');
    var elaboracaoDoCardapioPage = require('./page objects/elaboracaoDoCardapio.po.js');

    elaboracaoDoCardapioPage.abrir();
    elaboracaoDoCardapioPage.filtroInicial('MARMITEX ALMOCO','Fev','C','Custo Médio Líquido Atual','Custo Médio Líquido Atual');
    elaboracaoDoCardapioPage.excluiPeriodoTotalmente('08/02/2018','08/02/2018','Excluir Cardápio no Período');
    efetivosPlanejamentoPage.abrir();
    efetivosPlanejamentoPage.filtroInicial('08/02/2018', 'MARMITEX ALMOCO');
    //browser.sleep(2000);
    z.application.waitZhLoading();
    //Espera a mensagem de não há dados
    expect(element(by.css('#grid-35054435228195666132480 > div.body > div > div > div > p')).isPresent()).toBeTruthy();

});

it ('Compara efetivos de Planejamento com efetivos de Faturamento', function(){
    
    decache('./page objects/elaboracaoDoCardapio.po.js');
    var elaboracaoDoCardapioPage = require('./page objects/elaboracaoDoCardapio.po.js');

    var numeroCli = util.InteiroRandom(50, 100);
    var numeroFun = util.InteiroRandom(1, 10);
    var numeroDoa = util.InteiroRandom(1, 10);
    var numeroFat = util.InteiroRandom(1, 20);
    var numeroVenda = util.InteiroRandom(1, 10);
    var totalFaturado = numeroFat + numeroVenda;
    
    efetivosPlanejamentoPage.abrir();
    efetivosPlanejamentoPage.filtroInicial('02/02/2018', 'MARMITEX ALMOCO');
    efetivosPlanejamentoPage.preencheEfetivos(numeroCli,numeroFun,numeroDoa);
    z.component.footer.clickRightActionByLabel('Salvar');
    z.util.clickElement(by.css('#grid-35054435228195666132480 > div.body > div > div > div:nth-child(1)'));
    z.application.waitZhLoading();
    z.util.clickElement(by.css('#grid-350544352505037242481 > div.body > div > div > div:nth-child(1)'));
    //z.application.waitZhLoading();
    efetivosPlanejamentoPage.preencheEfetivosFaturamento(numeroFat,numeroVenda);
    z.component.footer.clickRightActionByLabel('Salvar');
    z.component.footer.clickLeftActionByLabel('Voltar');
    z.component.footer.clickLeftActionByLabel('Voltar');

    expect(z.component.alert.getText()).toBe('Somatório dos comensais dos clientes MARMITEX ALMOCO (' + numeroCli + ') difere da quantidade de clientes do servico (' + totalFaturado +').');
});

});

describe('Teste Efetivos (Planejamento) - Filial 9999', function() {

        beforeEach(function(){
        decache('zeedhi-functional-test-api');
        var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
        var z = new ZeedhiAPIConstructor(browser, protractor);

        decache('./page objects/login.po.js');
        var loginPage = require('./page objects/login.po.js');

        z.application.openOnContainer('#/product#dashboard');
        browser.driver.manage().window().maximize();

        browser.sleep(3000);
        browser.waitForAngular();
        loginPage.login('matheus.camara@teknisa.com','1');
        browser.waitForAngular();
        z.application.waitZhLoading();
    });


it ('Deve verificar o comportamento do parâmetro Permitir Lançar efetivos em Dias Após a Data de Processamento (desmarcado)', function(){
    decache('./page objects/efetivosPlanejamento.po.js')
    decache('zeedhi-functional-test-api');
    
    var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
    var efetivosPlanejamentoPage = require('./page objects/efetivosPlanejamento.po.js');
   

    var Dtprocessa = z.component.header.getSubtitle().then(function(Dtprocessamento)
    { 
       //Dtprocessamento.substring(0,10);
       efetivosPlanejamentoPage.abrir();
       //var aux = Dtprocessamento.replace(/\//g,'-');
       var DataSplit = Dtprocessamento.substring(0,10).split('/');
       var DataConvert = new Date (DataSplit[2], DataSplit[1] -1 , parseInt(DataSplit[0])+ 1);
       var DataString = DataConvert.toISOString().slice(0,10);
       var DataSplitString = DataString.split('-');
       var DataFinal = DataSplitString[2]+ '/' + DataSplitString[1] + '/' +DataSplitString[0];
       efetivosPlanejamentoPage.filtroInicial (DataFinal, 'MARMITEX ALMOCO');
       //browser.sleep(3000);
       z.application.waitZhLoading();
    });

    expect(z.component.alert.getText()).toBe('Não é permitido lançar efetivos em dias após a data de processamento.');
   
});

it ('Deve verificar o comportamento do parâmetro Permitir Lançar Efetivos sem Retirada do Planejamento', function(){
    decache('./page objects/efetivosPlanejamento.po.js')
    decache('zeedhi-functional-test-api');
    
    var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
    var efetivosPlanejamentoPage = require('./page objects/efetivosPlanejamento.po.js');
    var campoCli = element(by.css('#grid-35054435228195666132480 > div.body > div > div > div:nth-child(2) > div > input'));
    
    efetivosPlanejamentoPage.abrir();
    efetivosPlanejamentoPage.filtroInicial('29/01/2018', 'MARMITEX ALMOCO');


    z.util.clickElement(by.css('#grid-35054435228195666132480 > div.body > div > div > div:nth-child(2) > div'));
    campoCli.sendKeys(protractor.Key.TAB);
    //browser.sleep(3000);
    expect(z.component.alert.getText()).toBe('Não é permitido lançar efetivos sem Retirada do Planejamento');
   
});

});