'use strict';

function elaboracaoDoCardapio(){

	var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	var z = new ZeedhiAPIConstructor(browser, protractor);

	var self = this;

	/*
	rotina = 'N' -> Opção default, quando a tela é primeira a ser aberta após acessar o sistema
	Qualquer valor diferente de 'N' significa que a tela está sendo acessada após outra rotina
	*/
	this.abrir = function(rotina = 'N'){  
		browser.waitForAngular();
		//z.component.alert.clickMessageOk();
		z.component.menu.open();
        z.component.menu.clickByLabel('Planejamento');
        z.component.menu.clickByLabel('Cardápio');
        z.component.menu.clickByLabel('Elaboração do Cardápio');
        browser.waitForAngular();
        
    	/*
		if(rotina == 'N'){
        	z.application.waitZhLoading();
        	z.component.alert.clickMessageOk(); //Contorna o problema de mensagens do console
    	}
        */
	};

	this.selecionarServico = function(nmservico){
		z.field.fieldFunctions.click('NMSERVICO');
		z.widget.grid.click('NMSERVICO', nmservico,'0');
	};

	//Abre o calendário e seleciona um mês pelo nome abreviado (3 primeiras letras Ex: Jan, Fev)
	this.selecionarCardapio = function(mesCardapio){
		z.field.fieldFunctions.click('dataCardapio');
		z.field.calendar.clickMonth(mesCardapio);
	};

	/*Seleciona um tipo de montagem de cardápio
	'C' = montagem por número de comensais
	'P' = montagem por percentual de consumo*/
	this.montagemAtravesDe = function(tipoMontagem){
		if(tipoMontagem == 'C' || tipoMontagem == 'c')
			z.field.radioGroup.click('tipoComensais','Número de comensais');

		else if(tipoMontagem = 'P' || tipoMontagem == 'p')
			z.field.radioGroup.click('tipoComensais','Percentual de consumo')
	};

	this.tipoCustoPlanejado = function(custoPlanejado){
		z.field.fieldFunctions.click('NMCUSTOPLANEJADO');
		z.widget.list.clickItem(custoPlanejado);
	};

	this.tipoCustoRealizado = function(custoRealizado){
		z.field.fieldFunctions.click('NMCUSTOREALIZADO');
		z.widget.list.clickItem(custoRealizado);
	};

	//[ToDo] Adicionar filtros para Tipo de Custo e Data para exibição de custo
	this.filtroInicial = function(nmservico, mesCardapio, tipoMontagem, custoPlanejado, custoRealizado){
		self.selecionarServico(nmservico);
		self.selecionarCardapio(mesCardapio);
		self.montagemAtravesDe(tipoMontagem);
		self.tipoCustoPlanejado(custoPlanejado);
		self.tipoCustoRealizado(custoRealizado);

		z.component.footer.clickRightActionByLabel('Confirmar');
	};

	/*Substituição Zeedhi
	O método GetRowCoumnLocator não encontrava o locator das colunas do grid, pois após concatentar o gridId o mesmo verificava
	div.body>.nonbounce>div:nth-child . Este trecho foi alterado para div.body>body>div:nth-child
	*/
	this.clickColumn = function(gridId, row, column, hasCheckbox) {
        var locator = self.getRowColumnLocator(gridId, row, column, hasCheckbox);
        z.util.clickElement(locator);
    };

     this.getRowColumnLocator = function(gridId, row, column, hasCheckbox) {
        hasCheckbox = z.util.validateOptionalParameter(hasCheckbox, false);
        if (hasCheckbox) {
            return by.css('#grid-' + gridId + '>div.body>div>div:nth-child(' + (row + 1) + ')>div:nth-child(' + (column + 2) + ')');
        } else {
            return by.css('#grid-' + gridId + '>div.body>div>div:nth-child(' + (row + 1) + ')>div:nth-child(' + (column + 1) + ')');
        }
    };
    /* Fim substituição Zeedhi API */

	this.selecionarDiaAtualCardapio = function(){
		var today = new Date();
		var dd = today.getDate();

		self.clickColumn('21154635373500446320972', dd - 1, 2, false);
	};

	this.selecionarDiaCardapio = function(dia){
		self.clickColumn('21154635373500446320972', dia - 1, 2, false);
	};

	this.filtrarPrato = function(nmprato){
		z.application.waitZhLoading();
		z.field.fieldFunctions.click('NMPRATO');
		z.application.waitZhLoading();
		//Ao abrir o grid, o cursor deve estar no campo de pesquisa.
		z.util.pressKey(nmprato);
		z.widget.grid.click('NMPRATO',nmprato,'0');
	};

	/*Adiciona um prato ao primeiro tipo de prato no cardápio
	  nmprato: Nome do prato que será inserido
	  dia: dia do cardápio que será editado para inclusão do prato. Default = SYSDATE
	*/
	this.adicionarPrato = function(nmprato, dia = 'today'){
		if(dia == 'today')
			self.selecionarDiaAtualCardapio();

		else
			self.selecionarDiaCardapio(dia);

		self.filtrarPrato(nmprato);
		z.component.footer.clickRightActionByLabel('Salvar');
	};

	//Utiliza a rotina "Excluir Cardápio no Período" para apagar TODO o cardápio em um determinado período 
	this.excluiPeriodoTotalmente = function(dtinicio, dtfim, acao){
		z.component.footer.clickRightActionByLabel('Ações');
		//z.widget.list.clickItem('Excluir Cardápio no Período');
		z.util.clickElement(by.cssContainingText('.ng-binding' , acao));

		z.field.fieldFunctions.click('dataInicial');
		z.field.calendar.clickDate(dtinicio, 'pt_br');
		z.field.fieldFunctions.click('dataFinal');
		z.field.calendar.clickDate(dtfim, 'pt_br');
		z.field.fieldFunctions.click('listaTipoPrato');
		self.clickColumn ('9999','0','0',true);
		z.component.footer.clickRightActionByLabel('Ok');
		z.component.footer.clickRightActionByLabel('Excluir');
		z.component.alert.clickButton('Sim');

	};

}

module.exports = new elaboracaoDoCardapio();