var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
var z = new ZeedhiAPIConstructor(browser, protractor);
var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');
var loginPage = require('./page objects/login.po.js');
var elaboracaoDoCardapioPage = require( './page objects/elaboracaoDoCardapio.po.js');
var menuPage = require('./page objects/menu.po.js');

//var decache = require('C:/Users/iuryoliveira/AppData/Roaming/npm/node_modules/decache');
var decache = require('decache');
var Objects = function(){
    //PAGE OBJECTS MANAGEMENT

    this.getZeedhiApiConstructor = function(){
        decache('zeedhi-functional-test-api');
        var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
        var z = new ZeedhiAPIConstructor(browser, protractor);
    };
    this.getLogin = function(){
        decache('./page objects/login.po.js');
        var loginPage = require('./page objects/login.po.js');
    };

    this.getElaboracaoDoCardapio = function(){
        decache('./page objects/elaboracaoDoCardapio.po.js');
        var elaboracaoDoCardapioPage = require( './page objects/elaboracaoDoCardapio.po.js');
        return elaboracaoDoCardapioPage;
    };

    this.getRequisicaoPorServico = function(){
        decache('./page objects/requisicaoPorServico.po.js');
        var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');
        return requisicaoPorServicoPage;
    };

    this.getMenu = function(){
        decache('./page objects/menu.po.js');
        var menuPage = require('./page objects/menu.po.js'); 
    };
}

describe('Teste Requisição por Serviço', function() {

    beforeEach(function(){
        decache('zeedhi-functional-test-api');
        var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
        var z = new ZeedhiAPIConstructor(browser, protractor);

        decache('./page objects/login.po.js');
        var loginPage = require('./page objects/login.po.js');

        z.application.openOnContainer('#/product#dashboard');
        browser.driver.manage().window().maximize();

        browser.sleep(1000);
        browser.waitForAngular();
        loginPage.login('joana.almeida@teknisa.com','1');
        browser.waitForAngular();
        z.application.waitZhLoading();
        //expect(z.component.header.getTitle()).toBe('Início'); //Está logado
    });

    /*afterEach(function(){
        menuPage.inicio();
        menuPage.sair();
        browser.waitForAngular();
    });*/

    it('Deve acessar a tela [Requisição por Serviço] ', function() {
        requisicaoPorServicoPage.abrir();
        z.component.footer.clickLeftActionByLabel('Cancelar');
        expect(browser.getCurrentUrl()).toContain('pla00600_requisicao_por_servico');
    }, 30000);

    it('Deve elaborar cardápio para o dia atual e realizar o cálculo de Requisição por Serviço', function(){
        //Inclusão de registro na elaboração de cardápio para data atual
        decache('./page objects/elaboracaoDoCardapio.po.js');
        var elaboracaoDoCardapioPage = require( './page objects/elaboracaoDoCardapio.po.js');

        decache('./page objects/requisicaoPorServico.po.js');
        var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');

        elaboracaoDoCardapioPage.abrir();
        elaboracaoDoCardapioPage.filtroInicial('MARMITEX ALMOCO','Dez','P','Custo Médio Líquido Atual','Custo Médio Líquido Atual');
        elaboracaoDoCardapioPage.adicionarPrato('BISTECA NA BRASA');

        //Navegação à tela Padrão de Ciclo e filtra a data atual
        requisicaoPorServicoPage.abrir('S');
        requisicaoPorServicoPage.filtroInicial('MARMITEX ALMOCO', 'Matéria Prima');

        //Verifica existência dos itens da receita do produto
        requisicaoPorServicoPage.calcularRequisicao();
        expect(requisicaoPorServicoPage.gridHasText(1, 'SAL GROSSO - KG', true)).toBe(true);
    }, 150000);

    it('CRUD - Acessar a tela [Requisição por Serviço] e realizar cadastro', function(){
        //Acessa a tela Requisição por Serviço
        decache('./page objects/requisicaoPorServico.po.js');
        var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');

        requisicaoPorServicoPage.abrir();
        requisicaoPorServicoPage.filtroInicial('MARMITEX ALMOCO', 'Matéria Prima');

        requisicaoPorServicoPage.adicionarProduto('ACEM - KG');
        expect(requisicaoPorServicoPage.gridHasText(1,'ACEM - KG', true)).toBe(true);
    }, 150000);

    it('CRUD - Acessar a tela Requisição por Serviço e alterar um registro', function(){
        decache('zeedhi-functional-test-api');
        var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
        var z = new ZeedhiAPIConstructor(browser, protractor);

        decache('./page objects/requisicaoPorServico.po.js');
        var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');

        requisicaoPorServicoPage.abrir();
        requisicaoPorServicoPage.filtroInicial('MARMITEX ALMOCO', 'Matéria Prima');

        requisicaoPorServicoPage.calcularRequisicao();
        requisicaoPorServicoPage.alterarProduto('SAL GROSSO - KG', 15);
        requisicaoPorServicoPage.abrirSwipeProduto('SAL GROSSO - KG');
        expect(requisicaoPorServicoPage.getQtdExtra()).toContain(15);
        z.component.footer.clickLeftActionByLabel('Cancelar');
    }, 150000);

    it('CRUD - Editar registro pelo grid', function(){
        decache('./page objects/requisicaoPorServico.po.js');
        var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');

        requisicaoPorServicoPage.abrir();
        requisicaoPorServicoPage.filtroInicial('MARMITEX ALMOCO', 'Matéria Prima');

        requisicaoPorServicoPage.editarProdutoGrid('SAL GROSSO - KG', 1, 4, 10);
        expect(requisicaoPorServicoPage.gridHasText(4, '10,00', true)).toBe(true);
    }, 150000);
    
    it('CRUD - Acessar a tela Requisição por serviço e excluir um registro', function(){
        decache('./page objects/requisicaoPorServico.po.js');
        var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');

        requisicaoPorServicoPage.abrir();
        requisicaoPorServicoPage.filtroInicial('MARMITEX ALMOCO', 'Matéria Prima');

        requisicaoPorServicoPage.excluirProduto('1.05.01.600.00', 0);
        expect(requisicaoPorServicoPage.gridHasText(1,'SAL GROSSO - KG', true)).toBe(false);
    }, 150000);
    
});