var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
var z = new ZeedhiAPIConstructor(browser, protractor);

var loginPage = require('./page objects/login.po.js');
var elaboracaoDoCardapioPage = require( './page objects/elaboracaoDoCardapio.po.js');
var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');
var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');
var menuPage = require('./page objects/menu.po.js');
var util = require('./page objects/util.po.js');

var decache = require('decache');


describe('Teste Retirada (Planejamento)', function() {

    beforeEach(function(){
        decache('zeedhi-functional-test-api');
        var ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
        var z = new ZeedhiAPIConstructor(browser, protractor);

        decache('./page objects/login.po.js');
        var loginPage = require('./page objects/login.po.js');

        z.application.openOnContainer('#/product#dashboard');
        browser.driver.manage().window().maximize();

        browser.sleep(3000);
        browser.waitForAngular();
        loginPage.login('joana.almeida@teknisa.com','1');
        browser.waitForAngular();
        z.application.waitZhLoading();
    });

    
    it('Deve acessar a tela [Retirada (Planejamento)] ', function() {
        retiradaPlanejamentoPage.abrir();
        z.component.footer.clickLeftActionByLabel('Cancelar');
        expect(browser.getCurrentUrl()).toContain('pla02000_retirada_planejamento');
    }, 30000);
	
	it('Deve Eleborar Cardápio, Fazer Requisição por Serviço e Realizar a Retirada (Planejamento)', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		decache('./page objects/elaboracaoDoCardapio.po.js');
		decache('./page objects/requisicaoPorServico.po.js');
        var elaboracaoDoCardapioPage = require( './page objects/elaboracaoDoCardapio.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');
		var requisicaoPorServicoPage = require ('./page objects/requisicaoPorServico.po.js');
		
		/*
		//elaboração do cardápio
		elaboracaoDoCardapioPage.abrir();
		elaboracaoDoCardapioPage.filtroInicial('MARMITEX ALMOCO','Jan','C','Custo Médio Líquido Atual','Custo Médio Líquido Atual');
		elaboracaoDoCardapioPage.adicionarPrato('ASSADO MARINADO');

		//Requisão por Serviço
		requisicaoPorServicoPage.abrir();
        requisicaoPorServicoPage.filtroInicial('MARMITEX ALMOCO', 'Matéria Prima');
		requisicaoPorServicoPage.calcularRequisicao('S');
		*/
		//rotina Retirada (Planejamento)
		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO', '14');//informa serviço e dia atual
		browser.sleep(3000);
		
		//verifica se os produtos da receita estao corretos
		expect(retiradaPlanejamentoPage.gridHasText(1, 'ALHO - KG', true)).toBe(true);
		expect(retiradaPlanejamentoPage.gridHasText(1, 'AMIDO DE MILHO - KG', true)).toBe(true);
		expect(retiradaPlanejamentoPage.gridHasText(1, 'CEBOLA - KG', true)).toBe(true);
		expect(retiradaPlanejamentoPage.gridHasText(1, 'COLORAU EM PO - KG', true)).toBe(true);
		expect(retiradaPlanejamentoPage.gridHasText(1, 'OLEO DE SOJA - LT', true)).toBe(true);
		expect(retiradaPlanejamentoPage.gridHasText(1, 'PIMENTA DO REINO PRETA EM PO - KG', true)).toBe(true);
	}, 120000);
	
	it('CRUD - Acessar a tela de Retirada(Planejamento) e Adicionar produto', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		decache('./page objects/elaboracaoDoCardapio.po.js');
		decache('./page objects/requisicaoPorServico.po.js');
        var elaboracaoDoCardapioPage = require( './page objects/elaboracaoDoCardapio.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');
		var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');
		
		//elaboração do cardápio
		//elaboracaoDoCardapioPage.abrir();
		//elaboracaoDoCardapioPage.filtroInicial('MARMITEX ALMOCO','Dez','C','Custo Médio Líquido Atual','Custo Médio Líquido Atual');
		//elaboracaoDoCardapioPage.adicionarPrato('ASSADO MARINADO');
		
		//rotina Retirada (Planejamento)
		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','14');//informa serviço e dia atual
		
		//adicionar produto
		util.adicionar();
		retiradaPlanejamentoPage.adicionarProduto('ACEM - KG','CONSUMO DE PRODUCAO','50');
		browser.sleep(5000);
		expect(retiradaPlanejamentoPage.gridHasText(1,'ACEM - KG', true)).toBe(true);
	}, 120000);
	
	it('CRUD - Acessar a tela de Retirada(Planejamento) e Excluir produto', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage =  require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','14');//informa serviço e dia atual
		
		retiradaPlanejamentoPage.excluirProduto('CEBOLA - KG', 1);
		expect(retiradaPlanejamentoPage.gridHasText(1, 'CEBOLA - KG', true)).toBe(false);
	}, 120000);
	
	it('CRUD - Acessar a tela de Retirada(Planejamento) e Excluir o Primeiro Produto Listado', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage =  require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','14');//informa serviço e dia atual
		
		retiradaPlanejamentoPage.excluirProduto('ALHO - KG', 1);
		//expect(retiradaPlanejamentoPage.gridHasText(1, 'ALHO - KG', true)).toBe(false);
	}, 120000);
	
	it('CRUD - Acessar a tela de Retirada(Planejamento), Selecionar e Excluir todos os produtos', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO', '14');
		browser.sleep(2000);
		retiradaPlanejamentoPage.excluirTodosProdutos();
	}, 120000);
	
	it('CRUD - Acessar a tela de Retirada(Planejamento) e Editar Produto', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage =  require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','14');//Informa serviço e dia

		retiradaPlanejamentoPage.editarProduto('CEBOLA - KG', '10', 'S');
		browser.sleep(3000);
		
		expect(retiradaPlanejamentoPage.gridHasText(4, '10,00000', true)).toBe(true);
		browser.sleep(3000);
		expect(retiradaPlanejamentoPage.gridHasText(8, 'Evoluído', true)).toBe(true);
		browser.sleep(3000);
	}, 120000);
	
	it('CRUD - Acessar a tela de Retirada(Planejamento) e Inserir Quantidade Liberada', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage =  require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','14');//Informa serviço e dia atual

		retiradaPlanejamentoPage.inserirQtdConsumida('OLEO DE SOJA - LT', '10');
		browser.sleep(3000);
		//expect(retiradaPlanejamentoPage.gridHasText(4, '9,99800', true)).toBe(true);
		//expect(retiradaPlanejamentoPage.gridHasText(6, '11,00000', true)).toBe(true);
		//expect(retiradaPlanejamentoPage.gridHasText(8, 'Evoluído', true)).toBe(true);
		//browser.sleep(3000);
	}, 120000);
	
	it('CRUD - Inserir Quantidade Extra Para Produto Sem Estoque', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage =  require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','14');//Informa serviço e dia atual
		retiradaPlanejamentoPage.inserirQtdSemEstoque('AMIDO DE MILHO - KG', '200');
		browser.sleep(3000);
		
	}, 120000);
	
	it('CRUD - Inserir Quantidade Devolvida', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage =  require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','9');//Informa serviço e dia atual

		retiradaPlanejamentoPage.inserirQtdDevolvida('AMIDO DE MILHO - KG', '0,00010');
		browser.sleep(3000);
		
	}, 120000);
	
	it('CRUD - Inserir Quantidade Devolvida Maior que a Soma das Quantidades', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage =  require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','11');//Informa serviço e dia atual
		retiradaPlanejamentoPage.inserirQtdDevolvidaMaior('AMIDO DE MILHO - KG', '15');
		browser.sleep(3000);
	}, 120000);
	
	it('CRUD - Inserir Retirada Por Produto que Não Possua Requisição', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.realizarRetiradaSemRequisicao('MARMITEX ALMOCO','15','','','ACEM - KG','CONSUMO DE PRODUCAO','25');
		browser.sleep(2000);
		//expect(retiradaPlanejamentoPage.gridHasText(1,'ACEM - KG')).toBe(true);
	});
	
	it('CRUD - Inserir Produto sem Movimentação de Estoque', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','16');
		browser.sleep(2000);
		util.adicionar();
		retiradaPlanejamentoPage.adicionarProdutoSemEstoque('BIFE DO VAZIO - KG', 'CONSUMO DE PRODUCAO', '150');
		expect(retiradaPlanejamentoPage.gridHasText(1, 'BIFE DO VAZIO - KG')).toBe(false);
	});
	
	it('CRUD - Filtrar um serviço que utilize retirada por tipo de prato e que tenha requisição calculada', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('COFFE BREAK', '12');
	});
	
	it('CRUD - Filtrar um serviço que utilize retirada por tipo de prato e que não tenha requisição calculada', function() {
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.realizarRetiradaSemRequisicao('COFFE BREAK','14','PRATO PRINCIPAL','ALMONDEGAS AO SUGO','ALHO - KG','CONSUMO DE PRODUCAO','4,5');
		//expect(retiradaPlanejamentoPage.gridHasText(1, 'PRATO PRINCIPAL')).toBe(true);//gridId diferente
	});
	
	it('CRUD - Adicionar Tipo de Prato para um Serviço Por Tipo de Prato', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('COFFE BREAK', '12');
		util.adicionar();
		retiradaPlanejamentoPage.adicionarTipoDePrato('OPCAO DE PRATO', 'ASSADO MARINADO', 'ACEM - KG', 'CONSUMO DE PRODUCAO', '150');
	});
	
	it('CRUD - Adicionar Produto por Tipo de Prato', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('COFFE BREAK', '12');
		retiradaPlanejamentoPage.adicionarProdutoTpPrato('OPCAO DE PRATO', 'ALHO - KG', 'CONSUMO DE PRODUCAO', '15');
	});
	
	it('CRUD - Excluir Produto por Tipo de Prato', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('COFFE BREAK', '13');
		retiradaPlanejamentoPage.abrirSwipeTpPrato('OPCAO DE PRATO');
		retiradaPlanejamentoPage.excluirProduto('ALHO - KG',1, 'T');
		expect(retiradaPlanejamentoPage.gridHasText(1, 'ALHO - KG', true,'T')).toBe(false);
	});

	it('CRUD - Excluir Todos os Produtos por Tipo de Prato', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('COFFE BREAK', '15');
		retiradaPlanejamentoPage.excluirTodosProdutosTpPrato('OPCAO DE PRATO');
		expect(retiradaPlanejamentoPage.gridHasText(1, 'OPCAO DE PRATO', true, 'TP')).toBe(false);
	});

	it('CRUD - Editar Produto por Tipo de Prato', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('COFFE BREAK', '13');
		retiradaPlanejamentoPage.editarProdutoTpPrato('OPCAO DE PRATO', 'CEBOLA - KG', 'T','100');
	});

    it('AÇÕES - Acessar o menu Ações e Realizar Nova Retirada', function(){
    	decache('./page objects/retiradaPlanejamento.po.js');
    	var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

    	retiradaPlanejamentoPage.abrir();
    	retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO', '4');
    	retiradaPlanejamentoPage.acoesNovaRetirada('MARMITEX ALMOCO');
    	browser.sleep(3000);
    }, 120000);

    it('AÇÕES - Acessar o menu Ações e Excluir a Retirada', function(){
    	decache('./page objects/retiradaPlanejamento.po.js');
    	var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

    	retiradaPlanejamentoPage.abrir();
    	retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO');
    	retiradaPlanejamentoPage.acoesExcluirRetirada();
    	browser.sleep(3000);
    });

    it('AÇÕES - Acessar o menu Ações e Exibir o Romaneio', function(){
    	decache('./page objects/retiradaPlanejamento.jo.js');
    	var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

    	retiradaPlanejamentoPage.abrir();
    	retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO');
    	retiradaPlanejamentoPage.acoesExibirRomaneio('MARMITEX ALMOCO', '4', '10', '4', '10');
		//expect(retiradaPlanejamentoPage.gridHasText(1,'CEBOLA - KG', true)).toBe(true);
    });

    it('AÇÕES - Acessar o menu Ações e Exibir Resumo', function(){
    	decache('./page objects/retiradaPlanejamento.po.js');
    	decache('.page objects/requisicaoPorServico.po.js');
    	var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');
    	var requisicaoPorServicoPage = require('./page objects/requisicaoPorServico.po.js');

    	//Requisão por Serviço
		requisicaoPorServicoPage.abrir();
        requisicaoPorServicoPage.filtroInicial('MARMITEX ALMOCO', 'Matéria Prima','21');
		requisicaoPorServicoPage.calcularRequisicao('S');
		requisicaoPorServicoPage.alterarProduto('ALHO - KG', '100');
		browser.sleep(3000);

    	retiradaPlanejamentoPage.abrir('S');
    	retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO','21');
    	retiradaPlanejamentoPage.acoesExibirResumo();
    	browser.sleep(3000);
		expect(retiradaPlanejamentoPage.gridHasText(1,'ALHO - KG', true)).toBe(true);
    });

    it('AÇÕES - Acessar o menu Ações e Atualizar estoque com produto irregular', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		decache('./page objects/requisicaoPorServico.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');
		var requisicaoPorServicoPage = require ('./page objects/requisicaoPorServico.po.js');

		//Requisão por Serviço
		//requisicaoPorServicoPage.abrir();
        //requisicaoPorServicoPage.filtroInicial('MARMITEX ALMOCO', 'Matéria Prima');
		//requisicaoPorServicoPage.calcularRequisicao('S');
		//requisicaoPorServicoPage.alterarProduto('ALHO - KG', '400');
		//browser.sleep(3000);

		//rotina Retirada (Planejamento)
		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO', '11');
		browser.sleep(3000);

		retiradaPlanejamentoPage.acoesAtualizarEstoque(1, 'ALHO - KG','210');
		browser.sleep(3000);
    });

	it('AÇÕES - Acessar o menu Ações e estoque com sucesso', function(){
		decache('./page objects/retiradaPlanejamento.po.js');
		var retiradaPlanejamentoPage = require('./page objects/retiradaPlanejamento.po.js');

		retiradaPlanejamentoPage.abrir();
		retiradaPlanejamentoPage.filtroInicial('MARMITEX ALMOCO');
		browser.sleep(3000);
		retiradaPlanejamentoPage.acoesAtualizarEstoque(1, '','');
		browser.sleep(3000);
	});
	
});